//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cosmos/authz/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service.
///
/// Usage: instantiate `Cosmos_Authz_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Cosmos_Authz_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Cosmos_Authz_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func grants(
    _ request: Cosmos_Authz_V1beta1_QueryGrantsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGrantsRequest, Cosmos_Authz_V1beta1_QueryGrantsResponse>

  func granterGrants(
    _ request: Cosmos_Authz_V1beta1_QueryGranterGrantsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGranterGrantsRequest, Cosmos_Authz_V1beta1_QueryGranterGrantsResponse>

  func granteeGrants(
    _ request: Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest, Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse>
}

extension Cosmos_Authz_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "cosmos.authz.v1beta1.Query"
  }

  /// Returns list of `Authorization`, granted to the grantee by the granter.
  ///
  /// - Parameters:
  ///   - request: Request to send to Grants.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func grants(
    _ request: Cosmos_Authz_V1beta1_QueryGrantsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGrantsRequest, Cosmos_Authz_V1beta1_QueryGrantsResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.authz.v1beta1.Query/Grants",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGrantsInterceptors() ?? []
    )
  }

  /// GranterGrants returns list of `GrantAuthorization`, granted by granter.
  ///
  /// Since: cosmos-sdk 0.46
  ///
  /// - Parameters:
  ///   - request: Request to send to GranterGrants.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func granterGrants(
    _ request: Cosmos_Authz_V1beta1_QueryGranterGrantsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGranterGrantsRequest, Cosmos_Authz_V1beta1_QueryGranterGrantsResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.authz.v1beta1.Query/GranterGrants",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGranterGrantsInterceptors() ?? []
    )
  }

  /// GranteeGrants returns a list of `GrantAuthorization` by grantee.
  ///
  /// Since: cosmos-sdk 0.46
  ///
  /// - Parameters:
  ///   - request: Request to send to GranteeGrants.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func granteeGrants(
    _ request: Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest, Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse> {
    return self.makeUnaryCall(
      path: "/cosmos.authz.v1beta1.Query/GranteeGrants",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeGranteeGrantsInterceptors() ?? []
    )
  }
}

internal protocol Cosmos_Authz_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'grants'.
  func makeGrantsInterceptors() -> [ClientInterceptor<Cosmos_Authz_V1beta1_QueryGrantsRequest, Cosmos_Authz_V1beta1_QueryGrantsResponse>]

  /// - Returns: Interceptors to use when invoking 'granterGrants'.
  func makeGranterGrantsInterceptors() -> [ClientInterceptor<Cosmos_Authz_V1beta1_QueryGranterGrantsRequest, Cosmos_Authz_V1beta1_QueryGranterGrantsResponse>]

  /// - Returns: Interceptors to use when invoking 'granteeGrants'.
  func makeGranteeGrantsInterceptors() -> [ClientInterceptor<Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest, Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse>]
}

internal final class Cosmos_Authz_V1beta1_QueryClient: Cosmos_Authz_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Cosmos_Authz_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the cosmos.authz.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Cosmos_Authz_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Cosmos_Authz_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Cosmos_Authz_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Returns list of `Authorization`, granted to the grantee by the granter.
  func grants(request: Cosmos_Authz_V1beta1_QueryGrantsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Authz_V1beta1_QueryGrantsResponse>

  /// GranterGrants returns list of `GrantAuthorization`, granted by granter.
  ///
  /// Since: cosmos-sdk 0.46
  func granterGrants(request: Cosmos_Authz_V1beta1_QueryGranterGrantsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Authz_V1beta1_QueryGranterGrantsResponse>

  /// GranteeGrants returns a list of `GrantAuthorization` by grantee.
  ///
  /// Since: cosmos-sdk 0.46
  func granteeGrants(request: Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse>
}

extension Cosmos_Authz_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "cosmos.authz.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Grants":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Authz_V1beta1_QueryGrantsRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Authz_V1beta1_QueryGrantsResponse>(),
        interceptors: self.interceptors?.makeGrantsInterceptors() ?? [],
        userFunction: self.grants(request:context:)
      )

    case "GranterGrants":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Authz_V1beta1_QueryGranterGrantsRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Authz_V1beta1_QueryGranterGrantsResponse>(),
        interceptors: self.interceptors?.makeGranterGrantsInterceptors() ?? [],
        userFunction: self.granterGrants(request:context:)
      )

    case "GranteeGrants":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest>(),
        responseSerializer: ProtobufSerializer<Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse>(),
        interceptors: self.interceptors?.makeGranteeGrantsInterceptors() ?? [],
        userFunction: self.granteeGrants(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Cosmos_Authz_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'grants'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGrantsInterceptors() -> [ServerInterceptor<Cosmos_Authz_V1beta1_QueryGrantsRequest, Cosmos_Authz_V1beta1_QueryGrantsResponse>]

  /// - Returns: Interceptors to use when handling 'granterGrants'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGranterGrantsInterceptors() -> [ServerInterceptor<Cosmos_Authz_V1beta1_QueryGranterGrantsRequest, Cosmos_Authz_V1beta1_QueryGranterGrantsResponse>]

  /// - Returns: Interceptors to use when handling 'granteeGrants'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeGranteeGrantsInterceptors() -> [ServerInterceptor<Cosmos_Authz_V1beta1_QueryGranteeGrantsRequest, Cosmos_Authz_V1beta1_QueryGranteeGrantsResponse>]
}
