//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: evmos/erc20/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service.
///
/// Usage: instantiate `Evmos_Erc20_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Evmos_Erc20_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Evmos_Erc20_V1_QueryClientInterceptorFactoryProtocol? { get }

  func tokenPairs(
    _ request: Evmos_Erc20_V1_QueryTokenPairsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Erc20_V1_QueryTokenPairsRequest, Evmos_Erc20_V1_QueryTokenPairsResponse>

  func tokenPair(
    _ request: Evmos_Erc20_V1_QueryTokenPairRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Erc20_V1_QueryTokenPairRequest, Evmos_Erc20_V1_QueryTokenPairResponse>

  func params(
    _ request: Evmos_Erc20_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Erc20_V1_QueryParamsRequest, Evmos_Erc20_V1_QueryParamsResponse>
}

extension Evmos_Erc20_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "evmos.erc20.v1.Query"
  }

  /// Retrieves registered token pairs
  ///
  /// - Parameters:
  ///   - request: Request to send to TokenPairs.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func tokenPairs(
    _ request: Evmos_Erc20_V1_QueryTokenPairsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Erc20_V1_QueryTokenPairsRequest, Evmos_Erc20_V1_QueryTokenPairsResponse> {
    return self.makeUnaryCall(
      path: "/evmos.erc20.v1.Query/TokenPairs",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeTokenPairsInterceptors() ?? []
    )
  }

  /// Retrieves a registered token pair
  ///
  /// - Parameters:
  ///   - request: Request to send to TokenPair.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func tokenPair(
    _ request: Evmos_Erc20_V1_QueryTokenPairRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Erc20_V1_QueryTokenPairRequest, Evmos_Erc20_V1_QueryTokenPairResponse> {
    return self.makeUnaryCall(
      path: "/evmos.erc20.v1.Query/TokenPair",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeTokenPairInterceptors() ?? []
    )
  }

  /// Params retrieves the erc20 module params
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Evmos_Erc20_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Erc20_V1_QueryParamsRequest, Evmos_Erc20_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/evmos.erc20.v1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }
}

internal protocol Evmos_Erc20_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'tokenPairs'.
  func makeTokenPairsInterceptors() -> [ClientInterceptor<Evmos_Erc20_V1_QueryTokenPairsRequest, Evmos_Erc20_V1_QueryTokenPairsResponse>]

  /// - Returns: Interceptors to use when invoking 'tokenPair'.
  func makeTokenPairInterceptors() -> [ClientInterceptor<Evmos_Erc20_V1_QueryTokenPairRequest, Evmos_Erc20_V1_QueryTokenPairResponse>]

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Evmos_Erc20_V1_QueryParamsRequest, Evmos_Erc20_V1_QueryParamsResponse>]
}

internal final class Evmos_Erc20_V1_QueryClient: Evmos_Erc20_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Evmos_Erc20_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the evmos.erc20.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Evmos_Erc20_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Evmos_Erc20_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Evmos_Erc20_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// Retrieves registered token pairs
  func tokenPairs(request: Evmos_Erc20_V1_QueryTokenPairsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Erc20_V1_QueryTokenPairsResponse>

  /// Retrieves a registered token pair
  func tokenPair(request: Evmos_Erc20_V1_QueryTokenPairRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Erc20_V1_QueryTokenPairResponse>

  /// Params retrieves the erc20 module params
  func params(request: Evmos_Erc20_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Erc20_V1_QueryParamsResponse>
}

extension Evmos_Erc20_V1_QueryProvider {
  internal var serviceName: Substring { return "evmos.erc20.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "TokenPairs":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Erc20_V1_QueryTokenPairsRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Erc20_V1_QueryTokenPairsResponse>(),
        interceptors: self.interceptors?.makeTokenPairsInterceptors() ?? [],
        userFunction: self.tokenPairs(request:context:)
      )

    case "TokenPair":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Erc20_V1_QueryTokenPairRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Erc20_V1_QueryTokenPairResponse>(),
        interceptors: self.interceptors?.makeTokenPairInterceptors() ?? [],
        userFunction: self.tokenPair(request:context:)
      )

    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Erc20_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Erc20_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Evmos_Erc20_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'tokenPairs'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeTokenPairsInterceptors() -> [ServerInterceptor<Evmos_Erc20_V1_QueryTokenPairsRequest, Evmos_Erc20_V1_QueryTokenPairsResponse>]

  /// - Returns: Interceptors to use when handling 'tokenPair'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeTokenPairInterceptors() -> [ServerInterceptor<Evmos_Erc20_V1_QueryTokenPairRequest, Evmos_Erc20_V1_QueryTokenPairResponse>]

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Evmos_Erc20_V1_QueryParamsRequest, Evmos_Erc20_V1_QueryParamsResponse>]
}
